"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.mockerHandle = mockerHandle;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));

var _url = _interopRequireDefault(require("url"));

var _bodyParser = _interopRequireDefault(require("body-parser"));

var _utils = require("./utils");

function mockerHandle(param) {
  var _ref = param || {},
      _ref$options = _ref.options,
      options = _ref$options === void 0 ? {} : _ref$options,
      req = _ref.req,
      res = _ref.res,
      next = _ref.next,
      mocker = _ref.mocker,
      mockerKey = _ref.mockerKey;

  var bodyParserMethd = _bodyParser["default"].json((0, _objectSpread2["default"])({}, options.bodyParserJSON)); // 默认使用json解析

  /**
   * `application/x-www-form-urlencoded; charset=UTF-8` => `application/x-www-form-urlencoded`
   * Issue: https://github.com/jaywcjlove/mocker-api/issues/50
   */


  var contentType = req.get('Content-Type');
  contentType = contentType && contentType.replace(/;.*$/, '');

  if (options.bodyParserConf && options.bodyParserConf[contentType]) {
    // 如果存在options.bodyParserConf配置 {'text/plain': 'text','text/html': 'text'}
    switch (options.bodyParserConf[contentType]) {
      // 获取bodyParser的方法
      case 'raw':
        bodyParserMethd = _bodyParser["default"].raw((0, _objectSpread2["default"])({}, options.bodyParserRaw));
        break;

      case 'text':
        bodyParserMethd = _bodyParser["default"].text((0, _objectSpread2["default"])({}, options.bodyParserText));
        break;

      case 'urlencoded':
        bodyParserMethd = _bodyParser["default"].urlencoded((0, _objectSpread2["default"])({
          extended: false
        }, options.bodyParserUrlencoded));
        break;

      case 'json':
        bodyParserMethd = _bodyParser["default"].json((0, _objectSpread2["default"])({}, options.bodyParserJSON));
      //使用json解析 break;
    }
  } else {
    // 兼容原来的代码,默认解析
    // Compatible with the original code, default parsing
    switch (contentType) {
      case 'text/plain':
        bodyParserMethd = _bodyParser["default"].raw((0, _objectSpread2["default"])({}, options.bodyParserRaw));
        break;

      case 'text/html':
        bodyParserMethd = _bodyParser["default"].text((0, _objectSpread2["default"])({}, options.bodyParserText));
        break;

      case 'application/x-www-form-urlencoded':
        bodyParserMethd = _bodyParser["default"].urlencoded((0, _objectSpread2["default"])({
          extended: false
        }, options.bodyParserUrlencoded));
        break;
    }
  }

  bodyParserMethd(req, res, function () {
    var result = mocker[mockerKey];

    if (typeof result === 'function') {
      var rgxStr = ~mockerKey.indexOf(' ') ? ' ' : '';
      req.params = (0, _utils.pathMatch)({
        sensitive: false,
        strict: false,
        end: false
      })(mockerKey.split(new RegExp(rgxStr))[1])(_url["default"].parse(req.url).pathname);
      result(req, res, next);
    } else {
      res.json(result);
    }
  });
}
//# sourceMappingURL=mockerHandle.js.map