"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.proxyHandle = proxyHandle;

var _url = _interopRequireDefault(require("url"));

var _httpProxy = _interopRequireDefault(require("http-proxy"));

var _safe = _interopRequireDefault(require("colors-cli/safe"));

function proxyHandle(req, res) {
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  var proxyKey = arguments.length > 3 ? arguments[3] : undefined;
  var currentProxy = options.proxy[proxyKey];

  var url = _url["default"].parse(currentProxy);

  if (options.changeHost) {
    req.headers.host = url.host;
  }

  var _options$httpProxy = options.httpProxy,
      _options$httpProxy$op = _options$httpProxy.options,
      proxyOptions = _options$httpProxy$op === void 0 ? {} : _options$httpProxy$op,
      _options$httpProxy$li = _options$httpProxy.listeners,
      proxyListeners = _options$httpProxy$li === void 0 ? {} : _options$httpProxy$li;
  /**
   * rewrite target's url path. Object-keys will be used as RegExp to match paths.
   * https://github.com/jaywcjlove/mocker-api/issues/62
   */

  Object.keys(options.pathRewrite).forEach(function (rgxStr) {
    var rePath = req.path.replace(new RegExp(rgxStr), options.pathRewrite[rgxStr]);
    var currentPath = [rePath];

    if (req.url.indexOf('?') > 0) {
      currentPath.push(req.url.replace(/(.*)\?/, ''));
    }

    req.query = _url["default"].parse(req.url, true).query;
    req.url = req.originalUrl = currentPath.join('?');
  });

  var proxyHTTP = _httpProxy["default"].createProxyServer({});

  proxyHTTP.on('error', function (err) {
    console.error("".concat(_safe["default"].red_b.black(" Proxy Failed: ".concat(err.name)), " ").concat(err.message || '', " ").concat(err.stack || '', " !!"));
  });
  Object.keys(proxyListeners).forEach(function (event) {
    proxyHTTP.on(event, proxyListeners[event]);
  });
  proxyHTTP.web(req, res, Object.assign({
    target: url.href
  }, proxyOptions));
}
//# sourceMappingURL=proxyHandle.js.map